<?php

namespace models\lang;

class Codes
{
	// perl -M5.10.0 -ne 'chomp; @a = split /\|/; say "\"$a[1]\" => \"$a[0]\"," if $a[1];' tmp/ISO-639-2_utf-8.txt
	public const ALIASES = [
		"sqi" => "alb",
		"hye" => "arm",
		"eus" => "baq",
		"mya" => "bur",
		"zho" => "chi",
		"ces" => "cze",
		"nld" => "dut",
		"fra" => "fre",
		"kat" => "geo",
		"deu" => "ger",
		"ell" => "gre",
		"isl" => "ice",
		"mkd" => "mac",
		"mri" => "mao",
		"msa" => "may",
		"fas" => "per",
		"ron" => "rum",
		"slk" => "slo",
		"bod" => "tib",
		"cym" => "wel",
		// custom
		'jap' => 'jpn',
		'fr' => 'fre',
		'esp' => 'spa',
	];

	// wget http://www.loc.gov/standards/iso639-2/ISO-639-2_utf-8.txt
	// perl -M5.10.0 -ne 'chomp; @a = split /\|/; $a[4] =~ s/;.+| \(.+//; say "\"$a[2]\" => \"$a[4]\"," if $a[2];' ISO-639-2_utf-8.txt
	public const CODES2 = [
		"aa" => "afar",
		"ab" => "abkhaze",
		"af" => "afrikaans",
		"ak" => "akan",
		"sq" => "albanais",
		"am" => "amharique",
		"ar" => "arabe",
		"an" => "aragonais",
		"hy" => "arménien",
		"as" => "assamais",
		"av" => "avar",
		"ae" => "avestique",
		"ay" => "aymara",
		"az" => "azéri",
		"ba" => "bachkir",
		"bm" => "bambara",
		"eu" => "basque",
		"be" => "biélorusse",
		"bn" => "bengali",
		"bh" => "langues biharis",
		"bi" => "bichlamar",
		"bs" => "bosniaque",
		"br" => "breton",
		"bg" => "bulgare",
		"my" => "birman",
		"ca" => "catalan",
		"ch" => "chamorro",
		"ce" => "tchétchène",
		"zh" => "chinois",
		"cu" => "slavon d'église",
		"cv" => "tchouvache",
		"kw" => "cornique",
		"co" => "corse",
		"cr" => "cree",
		"cs" => "tchèque",
		"da" => "danois",
		"dv" => "maldivien",
		"nl" => "néerlandais",
		"dz" => "dzongkha",
		"en" => "anglais",
		"eo" => "espéranto",
		"et" => "estonien",
		"ee" => "éwé",
		"fo" => "féroïen",
		"fj" => "fidjien",
		"fi" => "finnois",
		"fr" => "français",
		"fy" => "frison occidental",
		"ff" => "peul",
		"ka" => "géorgien",
		"de" => "allemand",
		"gd" => "gaélique",
		"ga" => "irlandais",
		"gl" => "galicien",
		"gv" => "manx",
		"el" => "grec moderne",
		"gn" => "guarani",
		"gu" => "goudjrati",
		"ht" => "haïtien",
		"ha" => "haoussa",
		"he" => "hébreu",
		"hz" => "herero",
		"hi" => "hindi",
		"ho" => "hiri motu",
		"hr" => "croate",
		"hu" => "hongrois",
		"ig" => "igbo",
		"is" => "islandais",
		"io" => "ido",
		"ii" => "yi de Sichuan",
		"iu" => "inuktitut",
		"ie" => "interlingue",
		"ia" => "interlingua",
		"id" => "indonésien",
		"ik" => "inupiaq",
		"it" => "italien",
		"jv" => "javanais",
		"ja" => "japonais",
		"kl" => "groenlandais",
		"kn" => "kannada",
		"ks" => "kashmiri",
		"kr" => "kanouri",
		"kk" => "kazakh",
		"km" => "khmer central",
		"ki" => "kikuyu",
		"rw" => "rwanda",
		"ky" => "kirghiz",
		"kv" => "kom",
		"kg" => "kongo",
		"ko" => "coréen",
		"kj" => "kuanyama",
		"ku" => "kurde",
		"lo" => "lao",
		"la" => "latin",
		"lv" => "letton",
		"li" => "limbourgeois",
		"ln" => "lingala",
		"lt" => "lituanien",
		"lb" => "luxembourgeois",
		"lu" => "luba-katanga",
		"lg" => "ganda",
		"mk" => "macédonien",
		"mh" => "marshall",
		"ml" => "malayalam",
		"mi" => "maori",
		"mr" => "marathe",
		"ms" => "malais",
		"mg" => "malgache",
		"mt" => "maltais",
		"mn" => "mongol",
		"na" => "nauruan",
		"nv" => "navaho",
		"nr" => "ndébélé du Sud",
		"nd" => "ndébélé du Nord",
		"ng" => "ndonga",
		"ne" => "népalais",
		"nn" => "norvégien nynorsk",
		"nb" => "norvégien bokmål",
		"no" => "norvégien",
		"ny" => "chichewa",
		"oc" => "occitan",
		"oj" => "ojibwa",
		"or" => "oriya",
		"om" => "galla",
		"os" => "ossète",
		"pa" => "pendjabi",
		"fa" => "persan",
		"pi" => "pali",
		"pl" => "polonais",
		"pt" => "portugais",
		"ps" => "pachto",
		"qu" => "quechua",
		"rm" => "romanche",
		"ro" => "roumain",
		"rn" => "rundi",
		"ru" => "russe",
		"sg" => "sango",
		"sa" => "sanskrit",
		"si" => "singhalais",
		"sk" => "slovaque",
		"sl" => "slovène",
		"se" => "sami du Nord",
		"sm" => "samoan",
		"sn" => "shona",
		"sd" => "sindhi",
		"so" => "somali",
		"st" => "sotho du Sud",
		"es" => "espagnol",
		"sc" => "sarde",
		"sr" => "serbe",
		"ss" => "swati",
		"su" => "soundanais",
		"sw" => "swahili",
		"sv" => "suédois",
		"ty" => "tahitien",
		"ta" => "tamoul",
		"tt" => "tatar",
		"te" => "télougou",
		"tg" => "tadjik",
		"tl" => "tagalog",
		"th" => "thaï",
		"bo" => "tibétain",
		"ti" => "tigrigna",
		"to" => "tongan",
		"tn" => "tswana",
		"ts" => "tsonga",
		"tk" => "turkmène",
		"tr" => "turc",
		"tw" => "twi",
		"ug" => "ouïgour",
		"uk" => "ukrainien",
		"ur" => "ourdou",
		"uz" => "ouszbek",
		"ve" => "venda",
		"vi" => "vietnamien",
		"vo" => "volapük",
		"cy" => "gallois",
		"wa" => "wallon",
		"wo" => "wolof",
		"xh" => "xhosa",
		"yi" => "yiddish",
		"yo" => "yoruba",
		"za" => "zhuang",
		"zu" => "zoulou",
	];

	// wget http://www.loc.gov/standards/iso639-2/ISO-639-2_utf-8.txt
	// perl -M5.10.0 -ne 'chomp; @a = split /\|/; say "\"$a[0]\" => \"$a[4]\"," if $a[2];' tmp/ISO-639-2_utf-8.txt
	public const CODES3 = [
		"aar" => "afar",
		"abk" => "abkhaze",
		"afr" => "afrikaans",
		"aka" => "akan",
		"alb" => "albanais",
		"amh" => "amharique",
		"ara" => "arabe",
		"arg" => "aragonais",
		"arm" => "arménien",
		"asm" => "assamais",
		"ava" => "avar",
		"ave" => "avestique",
		"aym" => "aymara",
		"aze" => "azéri",
		"bak" => "bachkir",
		"bam" => "bambara",
		"baq" => "basque",
		"bel" => "biélorusse",
		"ben" => "bengali",
		"bih" => "langues biharis",
		"bis" => "bichlamar",
		"bos" => "bosniaque",
		"bre" => "breton",
		"bul" => "bulgare",
		"bur" => "birman",
		"cat" => "catalan",
		"cha" => "chamorro",
		"che" => "tchétchène",
		"chi" => "chinois",
		"chu" => "slavon d'église",
		"chv" => "tchouvache",
		"cor" => "cornique",
		"cos" => "corse",
		"cre" => "cree",
		"cze" => "tchèque",
		"dan" => "danois",
		"div" => "maldivien",
		"dut" => "flamand",
		"dzo" => "dzongkha",
		"eng" => "anglais",
		"epo" => "espéranto",
		"est" => "estonien",
		"ewe" => "éwé",
		"fao" => "féroïen",
		"fij" => "fidjien",
		"fin" => "finnois",
		"fre" => "français",
		"fry" => "frison occidental",
		"ful" => "peul",
		"geo" => "géorgien",
		"ger" => "allemand",
		"gla" => "gaélique",
		"gle" => "irlandais",
		"glg" => "galicien",
		"glv" => "manx",
		"gre" => "grec",
		"grn" => "guarani",
		"guj" => "goudjrati",
		"hat" => "haïtien",
		"hau" => "haoussa",
		"heb" => "hébreu",
		"her" => "herero",
		"hin" => "hindi",
		"hmo" => "hiri motu",
		"hrv" => "croate",
		"hun" => "hongrois",
		"ibo" => "igbo",
		"ice" => "islandais",
		"ido" => "ido",
		"iii" => "yi de Sichuan",
		"iku" => "inuktitut",
		"ile" => "interlingue",
		"ina" => "interlingua",
		"ind" => "indonésien",
		"ipk" => "inupiaq",
		"ita" => "italien",
		"jav" => "javanais",
		"jpn" => "japonais",
		"kal" => "groenlandais",
		"kan" => "kannada",
		"kas" => "kashmiri",
		"kau" => "kanouri",
		"kaz" => "kazakh",
		"khm" => "khmer central",
		"kik" => "kikuyu",
		"kin" => "rwanda",
		"kir" => "kirghiz",
		"kom" => "kom",
		"kon" => "kongo",
		"kor" => "coréen",
		"kua" => "kuanyama",
		"kur" => "kurde",
		"lao" => "lao",
		"lat" => "latin",
		"lav" => "letton",
		"lim" => "limbourgeois",
		"lin" => "lingala",
		"lit" => "lituanien",
		"ltz" => "luxembourgeois",
		"lub" => "luba-katanga",
		"lug" => "ganda",
		"mac" => "macédonien",
		"mah" => "marshall",
		"mal" => "malayalam",
		"mao" => "maori",
		"mar" => "marathe",
		"may" => "malais",
		"mlg" => "malgache",
		"mlt" => "maltais",
		"mon" => "mongol",
		"nau" => "nauruan",
		"nav" => "navaho",
		"nbl" => "ndébélé du Sud",
		"nde" => "ndébélé du Nord",
		"ndo" => "ndonga",
		"nep" => "népalais",
		"nno" => "norvégien nynorsk",
		"nob" => "norvégien bokmål",
		"nor" => "norvégien",
		"nya" => "chichewa",
		"oci" => "provençal",
		"oji" => "ojibwa",
		"ori" => "oriya",
		"orm" => "galla",
		"oss" => "ossète",
		"pan" => "pendjabi",
		"per" => "persan",
		"pli" => "pali",
		"pol" => "polonais",
		"por" => "portugais",
		"pus" => "pachto",
		"que" => "quechua",
		"roh" => "romanche",
		"rum" => "roumain",
		"run" => "rundi",
		"rus" => "russe",
		"sag" => "sango",
		"san" => "sanskrit",
		"sin" => "singhalais",
		"sla" => "langues slaves",
		"slo" => "slovaque",
		"slv" => "slovène",
		"sme" => "sami du Nord",
		"smo" => "samoan",
		"sna" => "shona",
		"snd" => "sindhi",
		"som" => "somali",
		"sot" => "sotho du Sud",
		"spa" => "espagnol",
		"srd" => "sarde",
		"srp" => "serbe",
		"ssw" => "swati",
		"sun" => "soundanais",
		"swa" => "swahili",
		"swe" => "suédois",
		"tah" => "tahitien",
		"tam" => "tamoul",
		"tat" => "tatar",
		"tel" => "télougou",
		"tgk" => "tadjik",
		"tgl" => "tagalog",
		"tha" => "thaï",
		"tib" => "tibétain",
		"tir" => "tigrigna",
		"ton" => "tongan (Îles Tonga)",
		"tsn" => "tswana",
		"tso" => "tsonga",
		"tuk" => "turkmène",
		"tur" => "turc",
		"twi" => "twi",
		"uig" => "ouïgour",
		"ukr" => "ukrainien",
		"urd" => "ourdou",
		"uzb" => "ouszbek",
		"ven" => "venda",
		"vie" => "vietnamien",
		"vol" => "volapük",
		"wel" => "gallois",
		"wln" => "wallon",
		"wol" => "wolof",
		"xho" => "xhosa",
		"yid" => "yiddish",
		"yor" => "yoruba",
		"zha" => "zhuang",
		"zul" => "zoulou",
	];

	// wget http://www.loc.gov/standards/iso639-2/ISO-639-2_utf-8.txt
	// perl -M5.10.0 -ne 'chomp; @a = split /\|/; say "\"$a[0]\" => \"$a[4]\"," if $a[2];' tmp/ISO-639-2_utf-8.txt
	public const CODES2TO3 = [
		"aa" => "﻿aar",
		"ab" => "abk",
		"af" => "afr",
		"ak" => "aka",
		"sq" => "alb",
		"am" => "amh",
		"ar" => "ara",
		"an" => "arg",
		"hy" => "arm",
		"as" => "asm",
		"av" => "ava",
		"ae" => "ave",
		"ay" => "aym",
		"az" => "aze",
		"ba" => "bak",
		"bm" => "bam",
		"eu" => "baq",
		"be" => "bel",
		"bn" => "ben",
		"bh" => "bih",
		"bi" => "bis",
		"bs" => "bos",
		"br" => "bre",
		"bg" => "bul",
		"my" => "bur",
		"ca" => "cat",
		"ch" => "cha",
		"ce" => "che",
		"zh" => "chi",
		"cu" => "chu",
		"cv" => "chv",
		"kw" => "cor",
		"co" => "cos",
		"cr" => "cre",
		"cs" => "cze",
		"da" => "dan",
		"dv" => "div",
		"nl" => "dut",
		"dz" => "dzo",
		"en" => "eng",
		"eo" => "epo",
		"et" => "est",
		"ee" => "ewe",
		"fo" => "fao",
		"fj" => "fij",
		"fi" => "fin",
		"fr" => "fre",
		"fy" => "fry",
		"ff" => "ful",
		"ka" => "geo",
		"de" => "ger",
		"gd" => "gla",
		"ga" => "gle",
		"gl" => "glg",
		"gv" => "glv",
		"el" => "gre",
		"gn" => "grn",
		"gu" => "guj",
		"ht" => "hat",
		"ha" => "hau",
		"he" => "heb",
		"hz" => "her",
		"hi" => "hin",
		"ho" => "hmo",
		"hr" => "hrv",
		"hu" => "hun",
		"ig" => "ibo",
		"is" => "ice",
		"io" => "ido",
		"ii" => "iii",
		"iu" => "iku",
		"ie" => "ile",
		"ia" => "ina",
		"id" => "ind",
		"ik" => "ipk",
		"it" => "ita",
		"jv" => "jav",
		"ja" => "jpn",
		"kl" => "kal",
		"kn" => "kan",
		"ks" => "kas",
		"kr" => "kau",
		"kk" => "kaz",
		"km" => "khm",
		"ki" => "kik",
		"rw" => "kin",
		"ky" => "kir",
		"kv" => "kom",
		"kg" => "kon",
		"ko" => "kor",
		"kj" => "kua",
		"ku" => "kur",
		"lo" => "lao",
		"la" => "lat",
		"lv" => "lav",
		"li" => "lim",
		"ln" => "lin",
		"lt" => "lit",
		"lb" => "ltz",
		"lu" => "lub",
		"lg" => "lug",
		"mk" => "mac",
		"mh" => "mah",
		"ml" => "mal",
		"mi" => "mao",
		"mr" => "mar",
		"ms" => "may",
		"mg" => "mlg",
		"mt" => "mlt",
		"mn" => "mon",
		"na" => "nau",
		"nv" => "nav",
		"nr" => "nbl",
		"nd" => "nde",
		"ng" => "ndo",
		"ne" => "nep",
		"nn" => "nno",
		"nb" => "nob",
		"no" => "nor",
		"ny" => "nya",
		"oc" => "oci",
		"oj" => "oji",
		"or" => "ori",
		"om" => "orm",
		"os" => "oss",
		"pa" => "pan",
		"fa" => "per",
		"pi" => "pli",
		"pl" => "pol",
		"pt" => "por",
		"ps" => "pus",
		"qu" => "que",
		"rm" => "roh",
		"ro" => "rum",
		"rn" => "run",
		"ru" => "rus",
		"sg" => "sag",
		"sa" => "san",
		"si" => "sin",
		"sk" => "slo",
		"sl" => "slv",
		"se" => "sme",
		"sm" => "smo",
		"sn" => "sna",
		"sd" => "snd",
		"so" => "som",
		"st" => "sot",
		"es" => "spa",
		"sc" => "srd",
		"sr" => "srp",
		"ss" => "ssw",
		"su" => "sun",
		"sw" => "swa",
		"sv" => "swe",
		"ty" => "tah",
		"ta" => "tam",
		"tt" => "tat",
		"te" => "tel",
		"tg" => "tgk",
		"tl" => "tgl",
		"th" => "tha",
		"bo" => "tib",
		"ti" => "tir",
		"to" => "ton",
		"tn" => "tsn",
		"ts" => "tso",
		"tk" => "tuk",
		"tr" => "tur",
		"tw" => "twi",
		"ug" => "uig",
		"uk" => "ukr",
		"ur" => "urd",
		"uz" => "uzb",
		"ve" => "ven",
		"vi" => "vie",
		"vo" => "vol",
		"cy" => "wel",
		"wa" => "wln",
		"wo" => "wol",
		"xh" => "xho",
		"yi" => "yid",
		"yo" => "yor",
		"za" => "zha",
		"zu" => "zul",
	];
}
